# -*- coding: utf-8 -*-

import sys
import xbmc
import xbmcgui
import xbmcplugin
import xbmcaddon
import unicodedata
import requests

import urllib
import re

_url = sys.argv[0]
try:
    _handle = int(sys.argv[1])
except:
    pass
addon = xbmcaddon.Addon(id='plugin.image.letaky')

LANG_DEF = {'0': 'sk', '1': 'cz'}
LANG = LANG_DEF[addon.getSetting("lang")]

# URL = 'http://127.0.0.1:8000/' + LANG
URL = 'http://jastrab.wz.sk/letaky/' + LANG

def encode(string):
    string = str(unicodedata.normalize('NFKD', string).encode('ascii', 'ignore'), "utf-8")
    return string


def get_url(**kwargs):
    return '{0}?{1}'.format(_url, urllib.parse.urlencode(kwargs, 'utf-8'))


def loadurl(url, req=None, headers={}):
    if req:
        req = urllib.parse.urlencode(req).encode('utf-8')
        req = urllib.request.Request(url, req, headers=headers)
    else:
        req = urllib.request.Request(url, headers=headers)
    with urllib.request.urlopen(req) as f:
        try:
            if f.getcode() == 200:
                response = f.read()
                return response.decode()
        except:
            return False

def fixTitle(title):
    title = title.replace('_', ' ')
    if len (title) < 4: #DM
        title = title.upper()
    else:
        title = title[0].upper() + title[1:]
    title = title.replace('.jpg', '')
    return title

def menu(path):
    # print ('===== menu =====')
    # print (path)
    s = loadurl( path)
    # a = re.finditer('<li><a href=\"(?P<href>[^/\"]+)/\">(?P<title>[^/<]+)/</a', s)
    # a = re.finditer('<a href=\"(?P<href>[^/\"]+)/\">(?P<title>[^/<]+)/</a', s)
    a = re.finditer('<a href=\"(?P<title>[^\/\"]+)\/\">', s)
    s = re.sub('[\n\r\t\0]', '', s)
    data = {}
    for aa in a:
        title = aa.group('title')
        name = fixTitle ( title )
        listitem = xbmcgui.ListItem(label=name)
        listitem.setIsFolder(True)
        #id = aa.group('href')
        id = title
        # print ('    ', id)
        url2 = path + '/' + id
        icon = url2 + '/__cover__.jpg'
        listitem.setArt({'thumb': icon, 'icon': icon})
        if len(id) > 10:
            # icon = url2 + '/__cover__.jpg'
            # listitem.setArt({'thumb': icon, 'icon': icon})
            url = get_url(action = 'pictures', path = encode(url2), id = id)
        else:
            url = get_url(action = 'folders', path = encode(url2), id = id)
        xbmcplugin.addDirectoryItem(_handle, url, listitem, True)
    xbmcplugin.endOfDirectory(_handle)

def menu_pictures(path, id):
    # print ('===== menu_pictures =====')
    # print (path)
    # print (id)
    url_pictures = path
    s = loadurl(url_pictures)
    # a = re.finditer('<li><a href=\"(?P<href>[^"]+)">(?P<title>[^<]+)</a', s)
    # a = re.finditer('<a href=\"(?P<href>[^"]+)">(?P<title>[^<]+)</a', s)
    a = re.finditer('<a href=\"(?P<title>[^\"]+)\">', s)
    data = {}
    for aa in a:
        # print (aa.group('href'), aa.group('title'))
        title = aa.group('title')
        name = fixTitle ( title)
        # url =  url_pictures + '/' + aa.group('href')
        url =  url_pictures + '/' + title
        if '.jpg' in aa.group('title'):
            if '__cover__' not in title:
                    listitem = xbmcgui.ListItem(label=name)
                    listitem.setInfo('pictures', {'title': name})
                    if addon.getSetting("thumb_enabled") == "false":
                        listitem.setArt({'thumb': 'DefaultPicture.png', 'icon': 'DefaultPicture.png'})
                    xbmcplugin.addDirectoryItem(_handle, url, listitem, False)

    global monitor
    xbmcplugin.endOfDirectory(_handle)
    

def router(paramstring):
    # print ('router=======')
    params = dict(urllib.parse.parse_qsl(paramstring))
    if params and 'action' in params:
        if params['action'] == 'folders':
            menu(params["path"])
        if params['action'] == 'pictures':
            menu_pictures(params["path"], params["id"])
    else:
        menu(URL)
